#include "command/vl.js"
#include "cycle/cycle.js"

VL.cycle_definitions = {
  'sax': {
    'soprano': [
       'SoprnoSx',
       'KennyGee',
       'HeyKenG_',
       'Branford',
       'TraneSop',
       'BrtSopSx',
      ],

    'alto': [
       'Alto_Sax',
       'Sanborn',
       'BirdAlto',
       'ExprAlto',
       'Desmond',
       'Koz_Alto',
       'Everette',
       'NY_Alto',
      ],

    'tenor': [
       'NY_Tenor',
       'TenorSax',
       'MBrecker',
       'PopTenor',
       'SoulTenr',
       'RaspyTnr',
       'Getz_Tnr',
       'JobimTnr',
       'TenorSub',
      ],

    'baritone': [
       'Bari_Sax',
       'TiteBari',
      ],

    'misc': [
       'CelloSax',
       'Sax_Sect',
       'Air_Sax',
       'Saxual',
       'Sanford',
      ],
    },

  'bass': {
    'electric': [
       'ElecBass',
       'MotownBs',
       'SteinBas',
       'FunkBass',
       'PickBass',
       'SnapBass',
       'Thumb_Bs',
       'TiteBass',
       'JacoBass',
       'StratoBs',
       'Sticky',
       'MuteBass',
       'Ac_Bass',
       'Juicy_Bs',
     ],

    'synth': [
       'Moog_Bs',
       'Bass1000',
       'SmooBass',
     ],
   },

  'brass' : {
    'brass':
     [
       'Euphnium',
       'Tuba',
      ],

    'tuba':
     [
       'Tuba',
      ],

    'horn':
     [
       'WX_Horn',
       'BrassHrn',
       'BriteHrn',
       'ff_Horn',
       'OrchHorn',
       'New_Horn',
      ],

    'trombone':
     [
       'Trombone',
       'Big_Bone',
       'BriteTbn',
       'ValveTbn',
       'Jam_Bone',
       'Bass_Tbn',
       'BcktMtTb',
       'DorseyTb',
      ],

    'trumpet':
     [
       'Trumpet',
       'Maynard',
       'Alpert',
       'Chet_Tpt',
       'Lead_Tpt',
       'ClassTpt',
       'StrMtTpt',
       'CupMtTpt',
       'WahMtTpt',
       'WaTptCC4',
       'HrmMtTpt',
       'Mute_Tpt',
       'Picc_Tpt',
       'Cornet',
       'Flugel',
       'Mangione',
      ],
    },

  'reed': {
    'clarinet':
     [
       'Clarinet',
       'JazzClar',
       'ClsClrnt',
       'Bs_Clrnt',
       'BrtBsClr',
      ],

    'doublereed':
     [
       'Oboe',
       'Eng_Horn',
       'SftEngHn',
       'Bassoon',
       'Flurinet',
       'Crumbon',
       'Klarina',
       'ThaiReed',
       'Chanter',
      ],
    },

  'wind': {
    'flute':
     [
       'Piccolo',
       'Flute',
       'Real_Flt',
       'SilvrFlt',
       'ClassFlt',
       'Nz_Flute',
       'VoxFlute',
       'AquaFlut',
       'OakFlute',
       'Bass_Flt',
       'PennyWhs',
       'TinWhist',
       'Flutofon',
       'Coca__',
       'Ocarina_',
       'Lonely',
       'Recorder',
       'IslePipe',
       'SoftPipe',
       'LitePipe',
       'YamaBotl',
      ],

    'harmonica':
     [
       'Harmonca',
       'MouthHrp',
       'BluesHrm',
       'Stevie_',
       'Toots_',
      ],

    'worldflute':
     [
       'Afri_Flt',
       'Inca_Flt',
       'Noze_Flt',
       'Quena',
       'Quena_x2',
       'PanFlute',
       'Andean',
       'Pan_Pipe',
       'Bali_Flt',
       'IndiaFlt',
       'Ambience',
       'WetFone',
       'Maya_Flt',
       'Shakuhat',
       'Bamboo',
       'PanPicol',
      ],
    },

  'bowed': {
    'cello':
     [
       'Cello',
       'SoloCell',
       'DrkCello',
       'Bow_Bass',
       'HiStrEns',
       'Pizzicat',
      ],

    'violin':
     [
       'Solo_Vln',
       'DrkVioln',
       'BrtVioln',
       'SweetVln',
       'Fiddle',
       'Viola',
       'SwtViola',
       'RosinVla',
      ],
    },

  'plucked': {
    'guitar': [
       'SteelGtr',
       'AcGuitar',
       'Flamenco',
       'SpainGtr',
       'NylonGtr',
       'SwtNylGt',
       'Les_Gtr',
       'Joe_Pass',
       'FMGuitar',
       'Lucille',
       '__PAT__',
       'EFXStrat',
       'ClnStrat',
       'Surf_Gtr',
       'Mute_Gtr',
       'WahGtCC4',
       'PatSynGt',
       'BluesGtr',
       'Clapton',
       'PopODGtr',
       'Carlos',
       'TubeGtr_',
       'FET_Guit',
       'Dist_Gtr',
       'Wah_Lead',
       'Wah_Dist',
       'GuitHero',
       'Eddie4th',
       'Feedback',
       'Hendrix',
     ],

    'harp': [
       'ElecHarp',
      ],
    },

  'percussion': {
    'keyboard':
     [
       'Jazz_B3',
       'Clavinet',
       'Funky',
      ],

    'drum':
     [
       'SteelDrm',
       'VL_Drums',
       'DinoPerc',
       'YamSteel',
      ],
    },

  'other': {
    'synth':
     [
       'TalkBox_',
       '_XTREME_',
       'Hercules',
       'SynClav',
       'Syncro',
       'Theremin',
       'Avalana',
       'Voxanne',
       'Beauty',
       'SpaceOut',
       'Ghost_Ld',
       'PtchNoiz',
       'BreathTb',
       'Air_Lead',
       'Breezer',
       'ZawiLead',
       'Voxofone',
       'Whistler',
       'Debussy',
       'Sines',
       'SmoothLd',
       'Slinky',
       'AirStick',
       'RotoFone',
       'Vox_Lead',
       'Squeezy',
       'Lyricon',
       'Ana_Lead',
       'Mobius',
       '_70sLead',
       'Osc_Lead',
       'Saw_Lead',
       'SAWS',
       'ResoSaws',
       'EML_Lead',
       'HPFilter',
       'EWI_ARP',
       'EWI_Lead',
       'Koz_Lead',
       'MattLead',
       'PATCHMAN',
       'Taurus',
       'Phaser',
       'SynZilla',
       'MegaSyn',
       'Winwood',
       'Pulse_Ld',
       'Corea',
       'SquareLd',
       'Korg_Ld',
       'LuckyMan',
       'Lyle',
       'Analog',
       'Nyle',
       'Floyd_Ld',
       'BorgHorn',
       'Freik',
       'Fazar',
       'Dungeon',
       'NevrLand',
       'Brekord1',
       'Brekord2',
       'Brekord3',
       'Moby',
       'Ossyncro',
      ],

    'accordion':
      [
       'Accordn_',
       'Concrtna',
      ],

    'weird':
     [
       'BowedSaw',
       'Jurassic',
       'Formula',
       'Waterphn',
       'Mu',
       'SpaceZoo',
      ],

    'world':
     [
       'Digirdoo',
       'Yangchin',
       'Asia_Plk',
       'JapanPlk',
       'Tambura',
       'Sitar',
       'ThaiReed',
       'Sitar2',
      ],
  },
};

VL.ReadCycleDefinition = function(data) {
  var data1 = data || VL.cycle_definitions;
  var result0 = new Cycle();
  for (var name1 in data1) {
    var result1 = new Cycle();
    result1.name = name1;
    result0.list.push(result1);
    var data2 = data1[name1];

    for (var name2 in data2) {
      var result2 = new Cycle(data2[name2]);
      result2.name = name2;
      result1.list.push(result2);
    }
  }

  return result0;
};
